# $Revision: 1.46 $, $Date: 2010/09/27 12:06:04 $
#
# TODO:
# - IMPORTANT rename: http://www.asterisk.org/zaptel-to-dahdi
# - Fix --without xpp:
#   + check_modules
#   unpackaged module: drivers/dahdi/xpp/xpd_bri
#   unpackaged module: drivers/dahdi/xpp/xpd_fxo
#   unpackaged module: drivers/dahdi/xpp/xpd_fxs
#   unpackaged module: drivers/dahdi/xpp/xpd_pri
#   unpackaged module: drivers/dahdi/xpp/xpp
#   unpackaged module: drivers/dahdi/xpp/xpp_usb
#
# Conditional build:
%bcond_without	dist_kernel	# without distribution kernel
%bcond_without  kernel		# don't build kernel modules
%bcond_with	oslec		# with Open Source Line Echo Canceller
%bcond_without	xpp		# without Astribank
%bcond_without	userspace	# don't build userspace packages
%bcond_with	verbose

%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif

%ifarch sparc
%undefine	with_smp
%endif
%ifarch alpha
%undefine	with_xpp
%endif
%if %{without kernel}
%undefine	with_dist_kernel
%endif

%define		rel	2
%define		pname	dahdi-linux
%define		FIRMWARE_URL http://downloads.digium.com/pub/telephony/firmware/releases
Summary:	DAHDI telephony device support
Summary(pl.UTF-8):	Obsługa urządzeń telefonicznych DAHDI
Name:		%{pname}%{_alt_kernel}
Version:	2.4.0
Release:	%{rel}
License:	GPL
Group:		Base/Kernel
Source0:	http://downloads.digium.com/pub/telephony/dahdi-linux/dahdi-linux-%{version}.tar.gz
# Source0-md5:	0114826395f76713486142b90d772f82
Source3:	%{FIRMWARE_URL}/dahdi-fw-oct6114-064-1.05.01.tar.gz
# Source3-md5:	88db9b7a07d8392736171b1b3e6bcc66
Source4:	%{FIRMWARE_URL}/dahdi-fw-oct6114-128-1.05.01.tar.gz
# Source4-md5:	c1f1a18d3e20d283f42c71e580a64b5a
Source5:	%{FIRMWARE_URL}/dahdi-fw-vpmadt032-1.07.tar.gz
# Source5-md5:	e1c7231d6225ac999cb18f4e858f66b6
Source6:	%{FIRMWARE_URL}/dahdi-fw-tc400m-MR6.12.tar.gz
# Source6-md5:	2ea860bb8a9d8ede2858b9557b74ee3c
Source7:	%{FIRMWARE_URL}/dahdi-fw-hx8-2.06.tar.gz
# Source7-md5:	a7f3886942bb3e9fed349a41b3390c9f
Patch0:		%{pname}-dummy.patch
Patch1:		%{pname}-build.patch
URL:		http://www.asterisk.org/
%if %{with dist_kernel}
BuildRequires:	kernel%{_alt_kernel}-module-build
%endif
BuildRequires:	perl-base
BuildRequires:	rpmbuild(macros) >= 1.379
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# Rules:
# - modules_X: single modules, just name module with no suffix
# - modules_X: subdir modules are just directory name with slash like dirname/
# - keep X and X_in in sync
# - X is used for actual building (entries separated with space), X_in for pld macros (entries separated with comma)

%define	modules_1	dahdi.o dahdi_dynamic.o dahdi_dynamic_eth.o dahdi_dynamic_ethmf.o dahdi_dynamic_loc.o dahdi_dummy.o dahdi_echocan_jpah.o dahdi_echocan_kb1.o dahdi_echocan_mg2.o dahdi_echocan_sec.o dahdi_echocan_sec2.o pciradio.o tor2.o wcfxo.o wct1xxp.o wctdm.o wcte11xp.o
%define	modules_1_in	dahdi,dahdi_dynamic,dahdi_dynamic_eth,dahdi_dynamic_ethmf,dahdi_dynamic_loc,dahdi_dummy,dahdi_echocan_jpah,dahdi_echocan_kb1,dahdi_echocan_mg2,dahdi_echocan_sec,dahdi_echocan_sec2,pciradio,tor2,wcfxo,wct1xxp,wctdm,wcte11xp
%define	modules_2	voicebus/ wct4xxp/ wcte12xp/ %{?with_xpp:xpp/}
%define	modules_2_in	voicebus/dahdi_voicebus,wct4xxp/wct4xxp,wcte12xp/wcte12xp,%{?with_xpp:xpp/xpd_bri,xpp/xpd_fxo,xpp/xpd_fxs,xpp/xpd_pri,xpp/xpp,xpp/xpp_usb}
%ifnarch alpha
%define	modules_nalpha	wctc4xxp/ wctdm24xxp/ dahdi_transcode.o wcb4xxp/
%define	modules_nalpha_in	wctc4xxp/wctc4xxp,wctdm24xxp/wctdm24xxp,dahdi_transcode,wcb4xxp/wcb4xxp
%endif
%define	modules		%{modules_1} %{modules_2}%{?modules_nalpha: %{modules_nalpha}}
%define	modules_in	%{modules_1_in},%{modules_2_in}%{?modules_nalpha:,%{modules_nalpha_in}}

%description
DAHDI telephony device driver.

%description -l pl.UTF-8
Sterownik do urządzeń telefonicznych DAHDI.

%package devel
Summary:	Header files for dahdi interface
Group:		Development/Libraries
# if base package contains shared library for which these headers are
#Requires:	%{name} = %{version}-%{release}
# if -libs package contains shared library for which these headers are
#Requires:	%{name}-libs = %{version}-%{release}

%description devel
Header files for dahdi interface.

%package udev
Summary:	udev rules for DAHDI kernel modules
Summary(pl.UTF-8):	Reguły udev dla modułów jądra Linuksa dla DAHDI
Release:	%{rel}
Group:		Base/Kernel
Requires:	dahdi-tools >= 2.2.0
Requires:	udev-core

%description udev
udev rules for DAHDI kernel modules.

%description udev -l pl.UTF-8
Reguły udev dla modułów jądra Linuksa dla DAHDI.

%package -n kernel%{_alt_kernel}-%{pname}
Summary:	DAHDI Linux kernel driver
Summary(pl.UTF-8):	Sterownik DAHDI dla jądra Linuksa
Release:	%{rel}@%{_kernel_ver_str}
Group:		Base/Kernel
Requires(post,postun):	/sbin/depmod
%if %{with dist_kernel}
%requires_releq_kernel
Requires(postun):	%releq_kernel
%{?with_oslec:Requires:	kernel-misc-oslec = 20070608-0.1@%{_kernel_ver_str}}
%endif

%description -n kernel%{_alt_kernel}-%{pname}
DAHDI telephony Linux kernel driver.

%description -n kernel%{_alt_kernel}-%{pname} -l pl.UTF-8
Sterownik dla jądra Linuksa do urządzeń telefonicznych DAHDI.

%prep
%setup -q -n %{pname}-%{version}
%patch0 -p1
%patch1 -p1

for a in %{SOURCE3} %{SOURCE4} %{SOURCE5} %{SOURCE6} %{SOURCE7}; do
	ln -s $a drivers/dahdi/firmware
	tar -C drivers/dahdi/firmware -xzf $a
done

cat > download-logger <<'EOF'
#!/bin/sh
# keep log of files make wanted to download in firmware/ dir
echo "$@" >> download.log
EOF
chmod a+rx download-logger

%build
%{__make} include/dahdi/version.h

%if %{with kernel}
%build_kernel_modules SUBDIRS=$PWD/drivers/dahdi DAHDI_BUILD_ALL=m HOTPLUG_FIRMWARE=yes DAHDI_MODULES_EXTRA=" " -m %{modules_in} KSRC=$PWD/o -C drivers/dahdi DAHDI_INCLUDE=$PWD/../../include

check_modules() {
	err=0
	for a in drivers/dahdi/{*/,}*.ko; do
		[[ $a = *-dist.ko ]] && continue
		[[ $a = *-up.ko ]] && continue
		[[ $a = *-smp.ko ]] && continue
		echo >&2 "unpackaged module: ${a%.ko}"
		err=1
	done

	[ $err = 0 ] || exit 1
}
check_modules
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT%{_includedir}/dahdi -p
%if %{with kernel}
cd drivers/dahdi
%install_kernel_modules -m %{modules_in} -d misc
cd ../..
%endif

%if %{with userspace}
install -d $RPM_BUILD_ROOT/etc/udev/rules.d

%{make} \
	DESTDIR=$RPM_BUILD_ROOT \
	install-devices \
	install-include
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n kernel%{_alt_kernel}-%{pname}
%depmod %{_kernel_ver}

%postun -n kernel%{_alt_kernel}-%{pname}
%depmod %{_kernel_ver}

%if %{with userspace}
%files devel
%defattr(644,root,root,755)
%{_includedir}/dahdi

%files udev
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) /etc/udev/rules.d/dahdi.rules
%config(noreplace) %verify(not md5 mtime size) /etc/udev/rules.d/xpp.rules
%endif

%if %{with kernel}
%files -n kernel%{_alt_kernel}-%{pname}
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/misc/*.ko*
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: dahdi-linux.spec,v $
Revision 1.46  2010/09/27 12:06:04  arekm
- release 2

Revision 1.45  2010/09/21 11:32:34  pawelz
- up to 2.4.0

Revision 1.44  2010/09/21 07:57:44  arekm
- release 7

Revision 1.43  2010/09/16 06:48:01  arekm
- release 6

Revision 1.42  2010/08/27 08:35:14  arekm
- release 5

Revision 1.41  2010/08/22 05:46:01  arekm
- release 4

Revision 1.40  2010/08/15 16:42:02  arekm
- release 3

Revision 1.39  2010/08/11 09:27:39  arekm
- release 2

Revision 1.38  2010/08/09 10:07:26  arekm
- fix build on 2.6.34

Revision 1.37  2010/08/09 09:38:40  zbyniu
- up to 2.3.0.1; standard kernel/dist_kernel bconds

Revision 1.36  2010/08/09 07:56:58  arekm
- release 6

Revision 1.35  2010/07/06 16:11:44  arekm
- release 5

Revision 1.34  2010/05/28 17:57:06  arekm
- release 4

Revision 1.33  2010/05/18 17:38:04  arekm
- release 3

Revision 1.32  2010/04/28 13:29:23  arekm
- release 2

Revision 1.31  2010/04/16 12:20:47  hawk
- updated to 2.3.0

Revision 1.30  2010/03/17 07:27:44  arekm
- release 16

Revision 1.29  2010/03/16 06:13:48  arekm
- release 15

Revision 1.28  2010/03/01 07:54:52  hawk
- fix build for alt_kernels

Revision 1.27  2010/02/15 14:42:23  sparky
- "kernel" bcond does not exist, removed reference to it
- dropped unused BR: module-init-tools, newt-devel, perl-tools-pod

Revision 1.26  2010/02/15 09:40:14  arekm
- release 13

Revision 1.25  2010/01/08 18:28:22  arekm
- rel 12; 2.6.32 fixes

Revision 1.24  2010/01/08 18:10:12  arekm
- release 11

Revision 1.23  2009/12/16 17:59:52  arekm
- release 10

Revision 1.22  2009/12/12 20:02:35  arekm
- release 9

Revision 1.21  2009/11/22 20:57:47  arekm
- release 8

Revision 1.20  2009/11/12 09:37:31  arekm
- release 7

Revision 1.19  2009/11/01 16:38:38  arekm
- release 6

Revision 1.18  2009/10/21 19:05:35  arekm
- release 5

Revision 1.17  2009/10/16 19:52:39  hawk
- release 4

Revision 1.16  2009/09/25 11:44:13  hawk
- userspace bcond

Revision 1.15  2009/09/25 11:29:53  hawk
- udev rules require /usr/share/dahdi/xpp_fxloader, R: dahdi-tools

Revision 1.14  2009/09/25 11:23:14  hawk
- updated TODO

Revision 1.13  2009/09/25 11:08:37  hawk
- install headers using make, install and package udev rules

Revision 1.12  2009/09/25 09:40:55  hawk
- added fixes from upstream, now it builds with 2.6.31

Revision 1.11  2009/09/25 09:18:37  hawk
- updated to 2.2.0.2

Revision 1.10  2009/09/24 22:48:27  hawk
- release 5

Revision 1.9  2009/09/17 20:21:21  hawk
- release 4

Revision 1.8  2009/08/05 08:51:16  arekm
- release 3

Revision 1.7  2009/08/02 11:31:11  hawk
- release 2

Revision 1.6  2009/07/14 19:10:26  hawk
- dopped bristuff (no -bristuff patch here so these drivers aren't
  available at all)
- dropped TODO (it was copied from zaptel.spec and these issue no
  longer exist)
- builds fine, release 1

Revision 1.5  2009/07/14 18:46:05  hawk
- sorted modules_1, fixed modules_2 - now it expands correctly

Revision 1.4  2009/07/14 18:20:35  hawk
- started work on 2.2.0.1

Revision 1.3  2009/04/29 08:38:35  arekm
- up to 2.1.0.4

Revision 1.2  2008/12/29 12:49:13  glen
- too much replace?

Revision 1.1  2008/12/26 05:15:33  aredridel
- added, replaces parts of zaptel.spec
